(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/common/http', 'rxjs', 'rxjs/operators'], factory) :
	(factory((global['ngx-httpclient-busy'] = {}),global.i0,global.common,global.http,global.rxjs,global.operators));
}(this, (function (exports,i0,common,http,rxjs,operators) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var CounterService = /** @class */ (function () {
    function CounterService() {
        var _this = this;
        this._connectionCounter = 0;
        this._observable = rxjs.Observable.create(function (subscriber) {
            _this._subscriber = subscriber;
        }).pipe(operators.share());
    }
    Object.defineProperty(CounterService.prototype, "observable", {
        get: /**
         * @return {?}
         */
        function () {
            return this._observable;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    CounterService.prototype.increment = /**
     * @return {?}
     */
    function () {
        this._connectionCounter += 1;
        this._next();
    };
    /**
     * @return {?}
     */
    CounterService.prototype.decrement = /**
     * @return {?}
     */
    function () {
        this._connectionCounter -= 1;
        this._next();
    };
    /**
     * @return {?}
     */
    CounterService.prototype._next = /**
     * @return {?}
     */
    function () {
        if (this._subscriber) {
            this._subscriber.next(this._connectionCounter);
        }
    };
    CounterService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] },
    ];
    /** @nocollapse */
    CounterService.ctorParameters = function () { return []; };
    /** @nocollapse */ CounterService.ngInjectableDef = i0.defineInjectable({ factory: function CounterService_Factory() { return new CounterService(); }, token: CounterService, providedIn: "root" });
    return CounterService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HttpClientBusyInterceptor = /** @class */ (function () {
    function HttpClientBusyInterceptor(_counter) {
        this._counter = _counter;
    }
    /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    HttpClientBusyInterceptor.prototype.intercept = /**
     * @param {?} req
     * @param {?} next
     * @return {?}
     */
    function (req, next) {
        var _this = this;
        this._counter.increment();
        return next.handle(req).pipe(operators.tap(function (evt) {
            if (evt instanceof http.HttpResponse) {
                _this._counter.decrement();
            }
        }), operators.catchError(function (err) {
            if (err instanceof http.HttpErrorResponse) {
                _this._counter.decrement();
            }
            return rxjs.throwError(err);
        }));
    };
    HttpClientBusyInterceptor.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] },
    ];
    /** @nocollapse */
    HttpClientBusyInterceptor.ctorParameters = function () { return [
        { type: CounterService }
    ]; };
    /** @nocollapse */ HttpClientBusyInterceptor.ngInjectableDef = i0.defineInjectable({ factory: function HttpClientBusyInterceptor_Factory() { return new HttpClientBusyInterceptor(i0.inject(CounterService)); }, token: HttpClientBusyInterceptor, providedIn: "root" });
    return HttpClientBusyInterceptor;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HttpClientBusyDirective = /** @class */ (function () {
    function HttpClientBusyDirective(_el, _renderer, _counter) {
        this._el = _el;
        this._renderer = _renderer;
        this._counter = _counter;
        this._httpClientBusyConfig = {};
    }
    /**
     * @param {?} count
     * @return {?}
     */
    HttpClientBusyDirective.prototype._updateStatus = /**
     * @param {?} count
     * @return {?}
     */
    function (count) {
        /** @type {?} */
        var busy = count > 0;
        /** @type {?} */
        var hasIdle = this._el.nativeElement.classList.contains(this._httpClientBusyConfig.idle);
        /** @type {?} */
        var hasBusy = this._el.nativeElement.classList.contains(this._httpClientBusyConfig.busy);
        if (busy) {
            if (this._httpClientBusyConfig.idle && hasIdle) {
                this._renderer.removeClass(this._el.nativeElement, this._httpClientBusyConfig.idle);
            }
            if (this._httpClientBusyConfig.busy && !hasBusy) {
                this._renderer.addClass(this._el.nativeElement, this._httpClientBusyConfig.busy);
            }
        }
        else {
            if (this._httpClientBusyConfig.busy && hasBusy) {
                this._renderer.removeClass(this._el.nativeElement, this._httpClientBusyConfig.busy);
            }
            if (this._httpClientBusyConfig.idle && !hasIdle) {
                this._renderer.addClass(this._el.nativeElement, this._httpClientBusyConfig.idle);
            }
        }
    };
    /**
     * @return {?}
     */
    HttpClientBusyDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._httpClientBusyConfig.idle = this.httpClientBusy.idle || 'fade';
        this._httpClientBusyConfig.busy = this.httpClientBusy.busy || '';
        this._updateStatus(0);
        this._autoUnsubscribe = this._counter.observable.subscribe(function (next) { return _this._updateStatus(next); });
    };
    /**
     * @return {?}
     */
    HttpClientBusyDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._autoUnsubscribe.unsubscribe();
    };
    HttpClientBusyDirective.decorators = [
        { type: i0.Directive, args: [{
                    selector: '[httpClientBusy]'
                },] },
    ];
    /** @nocollapse */
    HttpClientBusyDirective.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 },
        { type: CounterService }
    ]; };
    HttpClientBusyDirective.propDecorators = {
        httpClientBusy: [{ type: i0.Input }]
    };
    return HttpClientBusyDirective;
}());
/**
 * @record
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
var HttpClientBusyModule = /** @class */ (function () {
    function HttpClientBusyModule() {
    }
    /**
     * @return {?}
     */
    HttpClientBusyModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: HttpClientBusyModule
        };
    };
    HttpClientBusyModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, http.HttpClientModule],
                    declarations: [HttpClientBusyDirective],
                    exports: [HttpClientBusyDirective],
                    providers: [{ provide: http.HTTP_INTERCEPTORS, useClass: HttpClientBusyInterceptor, multi: true }]
                },] },
    ];
    return HttpClientBusyModule;
}());

exports.HttpClientBusyModule = HttpClientBusyModule;
exports.CounterService = CounterService;
exports.HttpClientBusyDirective = HttpClientBusyDirective;
exports.HttpClientBusyInterceptor = HttpClientBusyInterceptor;

Object.defineProperty(exports, '__esModule', { value: true });

})));
